package fr.natan.akkastreamfileprocessingapi.service

import fr.natan.akkastreamfileprocessingapi.models.ModelsAndJsonMap.{Episode, Person, TvSerie}

import scala.concurrent.Future

trait AkkaStreamFileProcessingFuture {
  def getPersonByIdFuture(personID: String): Future[Option[Person]]
  def getPersonByNameFuture(primaryName: String):  Future[Option[Person]]

  def getTvSerieByIdFuture(tvSerieID: String): Future[Option[TvSerie]]
  def getTvSeriesByPrimaryTitleFuture(tvSerieTitle: String):Future[IndexedSeq[TvSerie]]

  def getPersonsForTvSerieByTvSerieTitleFuture(tvSeriePrimaryTitle: String): Future[IndexedSeq[Person]]
  def getPersonsForTvSerieByTvSerieIDFuture(tvSerieId: String): Future[IndexedSeq[Person]]
  def getMaxPersonsFuture: Future[IndexedSeq[Person]]
  def getMaxTvSeriesFuture: Future[IndexedSeq[TvSerie]]
  def getMaxEpisodes: Future[IndexedSeq[Episode]]
}
